SystemOrganization addCategory: #BattleShip!
SystemOrganization addCategory: #'BattleShip-UI'!

SimpleButtonMorph subclass: #GameCell
	instanceVariableNames: 'cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip-UI'!

!GameCell methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 22:16'!
initialize
	super initialize.
	self borderWidth: 1.
	self on: #mouseDown send: #value to: self onClickExecutionBlock.
	self layoutPolicy: RowLayout new.
	self label: '' .
	self extent: 40@40 .
	color := (Color r:0 g:0 b:0.5 alpha:0.3)! !

!GameCell methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 22:08'!
initializeWith: aCell
	self initialize .
	cell := aCell ! !

!GameCell methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 21:11'!
onClickExecutionBlock
^[ ]! !

Object subclass: #BattleshipGame
	instanceVariableNames: 'boardSize container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip-UI'!

!BattleshipGame methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 21:26'!
addGuiControls
	| rowMorph newGameButton exitGameButton |
	rowMorph := Morph new
		layoutPolicy: RowLayout new;
		color: Color transparent.
	newGameButton := self createCtrlLabelled: 'New' onClickExecutes: [ self restart ].
	exitGameButton := self createCtrlLabelled: 'Exit' onClickExecutes: [ self exit ].
	rowMorph addMorph: exitGameButton.
	rowMorph addMorph: newGameButton.
	container addMorph: rowMorph! !

!BattleshipGame methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 21:33'!
createBoard
	self createBoardOfSize: 10! !

!BattleshipGame methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/6/2013 21:58'!
createBoardOfSize: aSize
| rowMorph aCell |
	boardSize := aSize .
	1 to:boardSize do:
	[ :row |
 		rowMorph := Morph new layoutPolicy: RowLayout new.
		rowMorph color: (Color red alpha:0).
		1 to: boardSize do: 
		[ :col | 
			aCell := GameCell new initialize .
			rowMorph addMorphBack: aCell.
		].
		container addMorphBack: rowMorph.
	].
	self addGuiControls! !

!BattleshipGame methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 21:28'!
createCtrlLabelled: aString onClickExecutes: aBlock
	| aCtrlButton |
	aCtrlButton := SimpleButtonMorph new label: aString.
	aCtrlButton
		color:
			(Color
				r: 0.2
				g: 0.2
				b: 0.2
				alpha: 0.2).
	aCtrlButton extent: 60 @ 30.
	aCtrlButton on: #click send: #value to: aBlock.
	^ aCtrlButton! !

!BattleshipGame methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 21:28'!
exit
	container delete.! !

!BattleshipGame methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 21:52'!
initialize
	container := Morph new
		layoutPolicy: TableLayout new;
		color: (Color red alpha: 0);
		openInWorld! !

!BattleshipGame methodsFor: 'as yet unclassified' stamp: 'CaiusBrindescu 5/5/2013 21:46'!
restart
	^ self! !

Object subclass: #Cell
	instanceVariableNames: 'isHit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

Cell subclass: #BigCaptainCell
	instanceVariableNames: 'ship noOfHits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!BigCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:54'!
getCharStatus
	super isHit
		ifTrue: [ 
			noOfHits = 1
				ifTrue: [ ^ 'x' ].
			noOfHits > 1
				ifTrue: [ ^ '@' ] ].
	^ '~'! !

!BigCaptainCell methodsFor: 'testing' stamp: 'MihaiCodoban 5/5/2013 17:55'!
hit
	noOfHits = 0
		ifTrue: [ 
			noOfHits := noOfHits + 1.
			super hit.
			^ ShipHitResult new hit ].
	noOfHits = 1
		ifTrue: [ 
			noOfHits := noOfHits + 1.
			ship destroy.
			^ ShipHitResult new sunk: ship name ].
		
	noOfHits := noOfHits + 1.
	
	^ ShipHitResult new! !

!BigCaptainCell methodsFor: 'initialize-release' stamp: 'YuLin 5/4/2013 17:22'!
initialize
	isHit := false.
	noOfHits := 0! !

!BigCaptainCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:49'!
isOccupied
	^true! !

!BigCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:40'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

!Cell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:20'!
getCharStatus
	self subclassResponsibility ! !

!Cell methodsFor: 'testing' stamp: 'MihaiCodoban 5/4/2013 18:47'!
hit
	isHit := true.
	^ShipHitResult new! !

!Cell methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 17:28'!
initialize 
	isHit := false! !

!Cell methodsFor: 'accessing' stamp: 'MihaiCodoban 5/4/2013 18:43'!
isHit
	^isHit! !

!Cell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:19'!
isOccupied
	self subclassResponsibility ! !

Cell subclass: #ShipCell
	instanceVariableNames: 'ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:34'!
getCharStatus
	self isHit
		ifTrue: [ ^ '@' ]
		ifFalse: [ ^ '~' ]! !

!ShipCell methodsFor: 'testing' stamp: 'MihaiCodoban 5/4/2013 18:47'!
hit
	| result |
	self isHit
		ifTrue: [ ^ ShipHitResult new ]
		ifFalse: [ 
			result := super hit.
			result hit.
			^ result ]! !

!ShipCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:29'!
isOccupied
	^true! !

!ShipCell methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 16:25'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

Cell subclass: #SmallCaptainCell
	instanceVariableNames: 'ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!SmallCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 17:00'!
getCharStatus
	self isHit
		ifTrue: [ ^ '@' ].
	^ '~'! !

!SmallCaptainCell methodsFor: 'testing' stamp: 'MihaiCodoban 5/5/2013 17:55'!
hit
	| result |
	self isHit
		ifFalse: [ 
			result := super hit.
			ship destroy.
			^ result sunk: ship name ].
	^ ShipHitResult new! !

!SmallCaptainCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:59'!
isOccupied
	^true! !

!SmallCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:56'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

Cell subclass: #WaterCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!WaterCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 17:03'!
getCharStatus
	self isHit ifTrue: [ ^'x' ].
	^'~'! !

!WaterCell methodsFor: 'testing' stamp: 'MihaiCodoban 5/4/2013 18:15'!
hit 
	^ super hit ! !

!WaterCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 17:02'!
isOccupied 
	^false! !

Object subclass: #Factory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

Factory subclass: #ShipFactory
	instanceVariableNames: 'layoutCatalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipFactory class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:54'!
new
	^ super new initialize! !

!ShipFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 11:45'!
buildShip: shipName
	^ self buildShip: shipName rotated: false.! !

!ShipFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 11:44'!
buildShip: shipName rotated: rotation
	| ship |
	ship := Ship named: shipName withLayout: (layoutCatalogue at: shipName).
	rotation ifTrue: [ ship rotate  ].
	
	^ship! !

!ShipFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:01'!
initialize
	layoutCatalogue := Dictionary new.
	
	layoutCatalogue at: 'Minesweeper' put: 'rr|SmallCaptainCell|ShipCell'.
	layoutCatalogue at: 'Destroyer' put: 'rrr|ShipCell|BigCaptainCell|ShipCell'.
	layoutCatalogue at: 'Battleship' put: 'rrrr|ShipCell|ShipCell|BigCaptainCell|ShipCell'.
	! !

!ShipFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:02'!
showShipNames
	^layoutCatalogue keys 
! !

Factory subclass: #WeaponsFactory
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!WeaponsFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:37'!
getBonusWeaponPackage
	| weapons |
	weapons := OrderedCollection new.
	
	weapons add: (self makeStrikeWeaponWithActivationCondition: (OneShipSunkCondition new player: player)).
	
	^weapons! !

!WeaponsFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:21'!
makeStrikeWeaponWithActivationCondition: anActivationCondition
	| layout |
	layout := Layout withLayout: 'rrrrr'. 
	^AreaHitWeapon withLayout: layout withActivationCondition: anActivationCondition  ForPlayer: player. ! !

!WeaponsFactory methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:21'!
player: aPlayer
	player := aPlayer.! !

Object subclass: #Grid
	instanceVariableNames: 'gridHeight gridWidth cells nrOfavailableShips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Grid methodsFor: 'update' stamp: 'MihaiCodoban 5/5/2013 22:00'!
at: aPoint addShip: aShip
	aShip placeOnGrid: self at: aPoint.
	nrOfavailableShips := nrOfavailableShips + 1.! !

!Grid methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:30'!
at: coordinate placeCell: aCell
 	cells at: coordinate x at: coordinate y put:  aCell! !

!Grid methodsFor: 'accessing' stamp: 'YuLin 5/4/2013 17:28'!
cells
	^cells! !

!Grid methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 17:12'!
hasCoordinate: aCoordinate
	| xOK yOK |
	
	xOK := (1 to: cells rowCount) rangeIncludes: aCoordinate x .
	yOK := (1 to: cells columnCount) rangeIncludes: aCoordinate y .
	
	^ xOK and: yOK.! !

!Grid methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 20:50'!
height: aHeight width: aWidth
	| i j |
	i := 1.
	gridHeight := aHeight.
	gridWidth := aWidth.
	nrOfavailableShips := 0.
	cells := Matrix rows: aHeight columns: aWidth.
	[ i <= aHeight ]
		whileTrue: [ 
			j := 1.
			[ j <= aWidth ]
				whileTrue: [ 
					cells at: i at: j put: WaterCell new.
					j := j + 1 ].
			i := i + 1 ]! !

!Grid methodsFor: 'update' stamp: 'MihaiCodoban 5/4/2013 18:07'!
hit: aPoint
	| result |
	result := (cells at: (aPoint x) at: (aPoint y)) hit.
	nrOfavailableShips = 0
		ifTrue: [ result surrender ].
	^ result! !

!Grid methodsFor: 'testing' stamp: 'MihaiCodoban 5/4/2013 12:02'!
isCellOccupiedat: point
	^(cells at: point x at: point y) isOccupied ! !

!Grid methodsFor: 'accessing' stamp: 'YuLin 5/4/2013 20:52'!
nrOfavailableShips
	^ nrOfavailableShips! !

!Grid methodsFor: 'print' stamp: 'YuLin 5/2/2013 20:52'!
peekGridToGui
	| toReturn i j cell |
	i := 1.
	toReturn := Matrix rows: gridHeight columns: gridWidth.
	[ i <= gridHeight ]
		whileTrue: [ 
			j := 1.
			[ j <= gridWidth ]
				whileTrue: [ 
					cell := cells at: i at: j.
					toReturn at: i at: j put: cell getCharStatus.
					j := j + 1 ].
			i := i + 1 ].
	^ toReturn! !

!Grid methodsFor: 'print' stamp: 'YuLin 5/2/2013 20:51'!
peekMyGridToGui
	| toReturn i j cell |
	i := 1.
	toReturn := Matrix rows: gridHeight columns: gridWidth.
	[ i <= gridHeight ]
		whileTrue: [ 
			j := 1.
			[ j <= gridWidth ]
				whileTrue: [ 
					cell := cells at: i at: j.
					toReturn at: i at: j put: '~'.
					cell isOccupied ifTrue: [ toReturn at: i at: j put: 'B'. ].
					j := j + 1 ].
			i := i + 1 ].
	^ toReturn! !

!Grid methodsFor: 'update' stamp: 'YuLin 5/4/2013 20:45'!
update: aSymbol 
	"decrease the number of ships if being notified"
	nrOfavailableShips := nrOfavailableShips - 1
	! !

Object subclass: #Layout
	instanceVariableNames: 'layout rotated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Layout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:30'!
withLayout: aLayout 
	|newLayout  |
	newLayout  := self new.
	newLayout initializeWith: aLayout.
	
	^newLayout! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 19:43'!
getCoordinatesFor: aPoint
	| coordinates varPoint |
	coordinates := OrderedCollection new.
	varPoint := aPoint.
	
	self layout
		do: [ :direction | 
			coordinates add: varPoint.
			varPoint := self getNextPointFor: varPoint with: direction ].
		
	^coordinates.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/6/2013 23:16'!
getNextPointFor: point with: direction
	| currentX currentY |
	currentX := point x.
	currentY := point y.
	direction = $d
		ifTrue: [ ^ Point x: currentX y: currentY - 1 ].
	direction = $u
		ifTrue: [ ^ Point x: currentX y: currentY + 1 ].
	direction = $r
		ifTrue: [ ^ Point x: currentX + 1 y: currentY ].
	direction = $l
		ifTrue: [ ^ Point x: currentX - 1 y: currentY ]! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:59'!
initializeWith: aLayout 
	self layout: ((aLayout findTokens: '|') first) .
	rotated := false.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:28'!
layout
	^layout.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:15'!
layout: aLayout 	
 layout := aLayout .! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 16:15'!
rotate
	self rotated not
		ifTrue: [ 
			self rotateCW.
			self rotated: true ]
		ifFalse: [ 
			self rotateCCW.
			self rotated: false ]! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 16:40'!
rotateCCW
	"D->R
	L->D
	R->U
	U->L"
	
	| newLayout |
	newLayout := ''.
	
	self layout do: [ :direction |
		direction = $d ifTrue: [ newLayout := newLayout, 'r' ].
		direction = $l ifTrue: [ newLayout := newLayout, 'd' ].
		direction = $r ifTrue: [ newLayout := newLayout, 'u' ].
		direction = $u ifTrue: [ newLayout := newLayout, 'l' ].
		 ].
	
	self layout: newLayout.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 16:40'!
rotateCW 
	"D->L
	L->U
	R->D
	U->R"
	
	| newLayout |
	newLayout := ''.
	
	self layout do: [ :direction |
		direction = $d ifTrue: [newLayout := newLayout, 'l' ].
		direction = $l ifTrue: [ newLayout := newLayout, 'u' ].
		direction = $r ifTrue: [ newLayout := newLayout, 'd' ].
		direction = $u ifTrue: [ newLayout := newLayout, 'r' ].
		 ].
	
	self layout: newLayout.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:38'!
rotated
 ^rotated! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:33'!
rotated: aBoolean
	rotated := aBoolean! !

Layout subclass: #ShipLayout
	instanceVariableNames: 'shipParts ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipLayout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 12:49'!
withLayout: aLayout forShip: aShip
	| shipLayout shipParts parts |
	shipLayout := self withLayout: aLayout.
	
	parts := aLayout findTokens: '|'.
	shipParts := parts copyFrom: 2 to: (parts) size.
	
	shipLayout shipParts: shipParts.
	shipLayout ship: aShip.
	
	^ shipLayout! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 21:19'!
createShipCellAt: index
	| cell |
	cell := (Smalltalk at: (shipParts at: index) asSymbol) new.
	cell ship: self ship.
	^ cell! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 21:06'!
getCellTypeAt: index! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 21:07'!
getCells! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 21:49'!
makeShipCellsAt: point
	| shipCells coordinates cell |
	shipCells := Dictionary new.
	
	coordinates := self getCoordinatesFor: point.
	
	coordinates
		withIndexDo: [  :coordinate :index | 
			cell := self createShipCellAt: index.
			shipCells at: coordinate put: cell ].
	
	^ shipCells! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 13:18'!
ship
	^ ship! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:32'!
ship: aShip
	ship := aShip! !

!ShipLayout methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:33'!
shipParts: aShipParts 
	shipParts := aShipParts ! !

Object subclass: #ManifestBattleShip
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ManifestBattleShip class methodsFor: 'meta data' stamp: 'MihaiCodoban 5/5/2013 21:00'!
rejectClasses
^ #()! !

!ManifestBattleShip class methodsFor: 'meta data' stamp: 'MihaiCodoban 5/5/2013 21:00'!
rejectRules
^ #()! !

!ManifestBattleShip class methodsFor: 'meta data' stamp: 'MihaiCodoban 5/5/2013 21:00'!
ruleCollectionProtocolRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#Layout #getCoordinatesFor: #false)) #'2013-05-05T21:00:58.96-05:00') )! !

Object subclass: #Player
	instanceVariableNames: 'grid playerName factory enemyShipsSunk bonusWeapons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Player methodsFor: 'initialize-release' stamp: 'MihaiCodoban 5/4/2013 16:51'!
addShip: shipName at: aPoint rotated: isRotated
	| ship |

	ship := factory buildShip: shipName rotated: isRotated.
	grid at: aPoint addShip: ship! !

!Player methodsFor: 'update' stamp: 'MihaiCodoban 5/5/2013 20:44'!
attack: anotherPlayer At: coordinate WithWeapon: aWeapon
	| result |
	result := anotherPlayer hitWithWeapon: aWeapon At: coordinate.
	
	(result isSunk or: result isSurrender) ifTrue: [self increaseEnemyShipsSunkBy: result affectedShipNames size].
	
	^result! !

!Player methodsFor: 'print' stamp: 'YuLin 5/2/2013 20:17'!
endGameInterrogate
	^ playerName + 'lost the game'! !

!Player methodsFor: 'accessing' stamp: 'MihaiCodoban 5/5/2013 19:10'!
enemyShipsSunk
	^enemyShipsSunk ! !

!Player methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:53'!
getUsableBonusWeapons
	| usableWeapons |
	
	usableWeapons := bonusWeapons select: [ :weapon | weapon canBeUsedByPlayer ].
	^usableWeapons. ! !

!Player methodsFor: 'accessing' stamp: 'YuLin 5/4/2013 17:28'!
grid
	^ grid! !

!Player methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 20:18'!
gridChangeInterrogate
	^ self peekGridToGui: nil! !

!Player methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 19:52'!
gridHeight: aHeight gridWidth: aWidth name: aName factory: aFactory
	playerName := aName.
	factory := aFactory .
	grid := Grid new height: aHeight width: aWidth.! !

!Player methodsFor: 'update' stamp: 'MihaiCodoban 5/5/2013 17:56'!
hit: aPoint
	"self deprecated: 'use hitWithWeapon:At:'."
	^self hitWithWeapon: SimpleWeapon new At: aPoint ! !

!Player methodsFor: 'update' stamp: 'MihaiCodoban 5/5/2013 22:04'!
hitWithWeapon: aWeapon At: aPoint
	|result|
	
	result := aWeapon applyOn: grid at: aPoint .
	^result ! !

!Player methodsFor: 'accessing' stamp: 'MihaiCodoban 5/5/2013 20:44'!
increaseEnemyShipsSunkBy: amount
	enemyShipsSunk := enemyShipsSunk + amount. ! !

!Player methodsFor: 'initialize-release' stamp: 'MihaiCodoban 5/5/2013 22:03'!
initialize 
	enemyShipsSunk := 0.
	bonusWeapons := WeaponsFactory new player: self; getBonusWeaponPackage.! !

!Player methodsFor: 'print' stamp: 'MihaiCodoban 5/4/2013 17:52'!
name
	^playerName ! !

!Player methodsFor: 'accessing' stamp: 'MihaiCodoban 5/4/2013 22:28'!
nrOfAvailableShips
	^ grid nrOfavailableShips ! !

!Player methodsFor: 'print' stamp: 'YuLin 5/2/2013 20:10'!
peekGridToGui: player
	player == self
		ifTrue: [ ^ grid peekMyGridToGui ]
		ifFalse: [ ^ grid peekGridToGui ]! !

Object subclass: #Ship
	instanceVariableNames: 'name cells shipLayout destroyed is'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Ship class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:57'!
named: aName withLayout: aLayout
	^ self new named: aName withLayout: aLayout.! !

!Ship methodsFor: 'adding' stamp: 'MihaiCodoban 5/2/2013 19:01'!
addCell: aCell
	cells add: aCell.! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/3/2013 14:24'!
checkCollisionOf: shipCells with: aGrid
	shipCells keys
		do: [ :coordinate | 
			(aGrid isCellOccupiedat: coordinate)
				ifTrue: [ GridCollisionError signal ] ]! !

!Ship methodsFor: 'initialize' stamp: 'MihaiCodoban 5/5/2013 22:00'!
destroy
	cells do: [ :eachCell | eachCell hit  ].
	destroyed := true.
	self changed: #destroyed "notify observers"! !

!Ship methodsFor: 'testing' stamp: 'MihaiCodoban 5/2/2013 20:02'!
isDistroyed
	^ destroyed! !

!Ship methodsFor: 'accessing' stamp: 'MihaiCodoban 5/4/2013 17:54'!
name
	^name! !

!Ship methodsFor: 'as yet unclassified' stamp: 'YuLin 5/3/2013 15:29'!
named: aName withLayout: aLayout
	name := aName.
	shipLayout := ShipLayout withLayout: aLayout forShip: self.
	cells := OrderedCollection new.! !

!Ship methodsFor: 'as yet unclassified' stamp: 'YuLin 5/4/2013 20:40'!
placeOnGrid: aGrid at: point
	| shipCells |
	shipCells := shipLayout makeShipCellsAt: point.
	
	self checkCollisionOf: shipCells with: aGrid.
	
	shipCells keysAndValuesDo: [ : coordinate : shipCell | aGrid at: coordinate placeCell: shipCell].	
	
	self addDependent: aGrid! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 20:01'!
rotate
	shipLayout rotate! !

!Ship methodsFor: 'accessing' stamp: 'YuLin 5/4/2013 15:51'!
shipLayout
	^ shipLayout! !

Object subclass: #ShipHitResult
	instanceVariableNames: 'isSunk isSurrender isHit affectedShipNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:59'!
affectedShipName
	| result |
	result := ''.
	(affectedShipNames isEmpty ) not
		ifTrue: [ 
			affectedShipNames do: [ :shipName | result := result , '|' , shipName ].
			^ result copyFrom: 2 to: result size ].
	^ result! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:31'!
affectedShipNames
	^affectedShipNames ! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:33'!
asString
	self isSurrender
		ifTrue: [ ^ 'SURRENDER' ].
	self isSunk
		ifTrue: [ ^ 'SUNK ' , self affectedShipName ].
	self isHit
		ifTrue: [ ^ 'HIT' ].
	^ 'MISS'! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:36'!
hit
	isHit := true.! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:29'!
initialize 
	isHit := false.
	isSunk := false.
	isSurrender := false.
	
	affectedShipNames := OrderedCollection new.
	! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:41'!
isHit
	^isHit! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:41'!
isSunk
 ^isSunk! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:41'!
isSurrender
	^isSurrender! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:39'!
mergeWith: anotherResult
	isHit := isHit or: anotherResult isHit.
	isSunk := isSunk or: anotherResult isSunk.
	isSurrender := isSurrender or: anotherResult isSurrender.
	
	affectedShipNames addAll: (anotherResult affectedShipNames )! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:41'!
sunk: aShipName  
	isSunk := true.
	affectedShipNames add: aShipName.! !

!ShipHitResult methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 17:59'!
surrender
	isSurrender := true.! !

Object subclass: #Weapon
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

Weapon subclass: #AreaHitWeapon
	instanceVariableNames: 'activationCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!AreaHitWeapon class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 22:29'!
withLayout: aLayout ForPlayer: aPlayer
	| weapon |
	
	weapon := self new.
	weapon layout: aLayout.
	weapon player: aPlayer.
	
	^weapon! !

!AreaHitWeapon class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:25'!
withLayout: aLayout withActivationCondition: anActivationCondition ForPlayer: aPlayer
	| weapon |
	
	weapon := self new.
	weapon layout: aLayout.
	weapon player: aPlayer.
	weapon activationCondition: anActivationCondition.
	
	^weapon! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:26'!
activationCondition: anActivationCondition
	activationCondition := anActivationCondition .! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 16:59'!
applyOn: aGrid at: coordinate
	"performs attack on the grid at the specified layout. Return attack status"

	| results |
	results := OrderedCollection new.
	
	(self layout getCoordinatesFor: coordinate)
		do: [ :hitCoordinate | 
			(aGrid hasCoordinate: hitCoordinate)
				ifTrue: [ results add: (aGrid hit: hitCoordinate) ] ].
	
	^ self mergeResults: results! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:49'!
canBeUsedByPlayer
	^ activationCondition isActive ! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:55'!
getDescription 	
	^ 'Multi area hit. Activated when: ', activationCondition getDescription.! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 22:22'!
layout
	^layout! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 22:20'!
layout: aLayout
	layout := aLayout.! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 17:15'!
mergeResults: results
	| aggregateResult |
	aggregateResult := ShipHitResult new.
	
	results do: [:result | aggregateResult mergeWith: result ].
	
	^aggregateResult.! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 22:22'!
player
	^player! !

!AreaHitWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 22:21'!
player: aPlayer
	player := aPlayer! !

Weapon subclass: #SimpleWeapon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!SimpleWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 22:06'!
applyOn: aGrid at: coordinate
	"performs attack on the grid at the specified coordinate. Return attack status"

	^aGrid hit: coordinate.! !

!SimpleWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 22:07'!
canBeUsedByPlayer
	^true! !

!SimpleWeapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:56'!
getDescription
	^'Basic weapon'! !

!Weapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 22:03'!
applyOn: aGrid at: coordinate
	"performs attack on the grid at the specified coordinate. Return attack status"
	self subclassResponsibility ! !

!Weapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/4/2013 21:58'!
canBeUsedByPlayer
	self subclassResponsibility ! !

!Weapon methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:53'!
getDescription
	self subclassResponsibility ! !

Object subclass: #WeaponActivationCondition
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

WeaponActivationCondition subclass: #OddSunkenShipsCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!OddSunkenShipsCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:57'!
getDescription 
	^'Player destroyed an odd number of enemy ships'! !

!OddSunkenShipsCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:33'!
isActive
	^self player enemyShipsSunk odd.! !

WeaponActivationCondition subclass: #OneShipSunkCondition
	instanceVariableNames: 'activated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!OneShipSunkCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:39'!
activate
	activated := true .! !

!OneShipSunkCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:57'!
getDescription 	
	^ 'Player has sunk his first enemy ship'! !

!OneShipSunkCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:38'!
hasActivated
 ^activated.! !

!OneShipSunkCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:39'!
initialize
	activated := false.! !

!OneShipSunkCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 20:49'!
isActive

	self hasActivated
		ifFalse: [ 
			self player enemyShipsSunk = 1
				ifTrue: [ 
					self activate.
					^ true ] ].
	^ false! !

WeaponActivationCondition subclass: #TrueCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!TrueCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:58'!
getDescription
	^'Always active'! !

!TrueCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:48'!
isActive 
	^true.! !

!WeaponActivationCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 21:56'!
getDescription
	self subclassResponsibility ! !

!WeaponActivationCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:31'!
isActive
	^ self subclassResponsibility ! !

!WeaponActivationCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:31'!
player
	^ player.! !

!WeaponActivationCondition methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/5/2013 18:31'!
player: aPlayer
	player := aPlayer.! !

Error subclass: #GridCollisionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!
